=== debian/changelog ===
svt-av1 (0.8.7+dfsg-1) unstable; urgency=medium

  * Initial Debian release. (Closes: #993237)

 -- Dylan Aïssi <daissi@debian.org>  Sun, 29 Aug 2021 09:57:49 +0200
