=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                yasm
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/AOMediaCodec/SVT-AV1
 Vcs-Browser: https://salsa.debian.org/multimedia-team/svt-av1
